#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <limits.h>
#include <pthread.h>

/*
This demo is a little demonstration of how to add
elements while sorting. It's the same as with the old version, 
only the algorithm is changed.
The style isnt good, and i know it, but this is just to see if it works,
and it does. Try with several numbers, i wont work for small arrays because
of multitasking nature. With 100 numbers it works just fine for me (./demopth `seq 100 1`).
Please if you do another implementation of this, email it to me.

Alberto Bertogli - albertogli@altavista.net
9/2000 - Pinamar, Buenos Aires, Argentina
http://absort.sourceforge.net

*/

int *s, *m, *o, argcc;


pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;

void p(int *);
void absortth(int *);
void print(int *);
void move(void);

void p(int *v) {
    register int t;

    t = *v;
    *v = *(v + 1);
    *(v + 1) = t;
}

void absortth(int *x) {
	int i = 1;
	while 
	  ( printf("absort(): attemping to lock mutex\n"),
	  pthread_mutex_lock(&mutex),
	  (x <= m) ) {
		printf("absort(): mutex locked\n");
		if(*x > *(x + 1)) {
			p(x--);
			i++;
		}
		else {
			x += i;
			i = 1;
		}
/*		(*x > *(x + 1)) ? p(x--) : x++; old version */
		printf("x:%d - ", *x);
		print(o);
		pthread_mutex_unlock(&mutex);
		printf("absort(): mutex unlocked\n");
    }
    pthread_mutex_unlock(&mutex);
    printf("absort(): mutex unlocked - final call\n");

}


void print(int *q) {
    int i;
    for (i = 0; i < argcc; i++)
	printf("%d ", q[i]);
    printf("- %d\n", *m);

}

void move(void) {
    int ptmp;
    printf("move(): attemping to lock mutex\n");
    ptmp = pthread_mutex_lock(&mutex);
    printf("move(): mutex locked %d\n", ptmp);
 
    m = o + argcc - 2;
    printf("move(): reallocated m\n");

    pthread_mutex_unlock(&mutex);
    printf("move(): mutex unlocked\n");
}


extern int main(int argc, char *argv[]) {

    int i = 0;

    pthread_t absort_th;
    pthread_t move_th;


   if (argc == 1) {
	printf("No arguments\n");
	exit(1);
    }
   
    s = (int *) malloc((size_t) argc);
    free(s);

    s[0] = INT_MIN;

    for (i = 1; i < argc; i++)
	s[i] = atoi(argv[i]);

    o = s;
    m = s + argc - 5;
    argcc = argc;


    printf("* "); print(s);

    pthread_mutex_init(&mutex, NULL);

    pthread_create(&absort_th, NULL, (void *) absortth, s);
    pthread_create(&move_th, NULL, (void *) move, NULL);

    pthread_join(move_th, NULL);
    pthread_join(absort_th, NULL);


    printf("* "); print(s);


    exit(0);
}
